<script>
  import { createEventDispatcher, onDestroy } from "svelte";

  const dispatch = createEventDispatcher();
  const close = () => dispatch("close");

  export let categories;
  let modal;

  const handle_keydown = (e) => {
    if (e.key === "Escape") {
      close();
      return;
    }

    if (e.key === "Tab") {
      // trap focus
      const nodes = modal.querySelectorAll("*");
      const tabbable = Array.from(nodes).filter((n) => n.tabIndex >= 0);

      let index = tabbable.indexOf(document.activeElement);
      if (index === -1 && e.shiftKey) index = 0;

      index += tabbable.length + (e.shiftKey ? -1 : 1);
      index %= tabbable.length;

      tabbable[index].focus();
      e.preventDefault();
    }
  };

  const previously_focused =
    typeof document !== "undefined" && document.activeElement;

  if (previously_focused) {
    onDestroy(() => {
      previously_focused.focus();
    });
  }

  let prefix = "";
  let id = "";
  let name = "";
  let i = 0;

  $: filteredCategories = prefix
    ? categories.filter((category) => {
        const name = `${category.name}, ${category.id}`;
        return name.toLowerCase().startsWith(prefix.toLowerCase());
      })
    : categories;

  $: selected = filteredCategories[i];

  $: reset_inputs(selected);

  function create() {
    categories = categories.concat({ id, name });
    i = categories.length - 1;
    id = name = "";
  }

  function update() {
    selected.id = id;
    selected.name = name;
    categories = categories;
  }

  function remove() {
    // Remove selected category from the source array (categories), not the filtered array
    const index = categories.indexOf(selected);
    categories = [...categories.slice(0, index), ...categories.slice(index + 1)];

    id = name = "";
    i = Math.min(i, filteredCategories.length - 2);
  }

  function reset_inputs(category) {
    id = category ? category.id : "";
    name = category ? category.name : "";
  }
</script>

<svelte:window on:keydown={handle_keydown} />

<div class="modal-background" on:click={close} />

<div class="modal" role="dialog" aria-modal="true" bind:this={modal}>
  <slot name="header" />
  <hr />
  <slot />
  <hr />

  <input placeholder="filter prefix" bind:value={prefix} />

  <select bind:value={i} size={5}>
    {#each filteredCategories as category, i}
      <option value={i}>{category.name}</option>
    {/each}
  </select>

  <label><input bind:value={name} placeholder="name" /></label>

  <div class="buttons">
    <button on:click={create} disabled={!name}>create</button>
    <button on:click={update} disabled={!name || !selected}
      >update</button
    >
    <button on:click={remove} disabled={!selected}>delete</button>
  </div>
  <!-- svelte-ignore a11y-autofocus -->
  <button autofocus on:click={close}>close modal</button>
</div>

<style>
  .modal-background {
    position: fixed;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background: rgba(0, 0, 0, 0.3);
  }

  .modal {
    position: absolute;
    left: 50%;
    top: 50%;
    width: calc(100vw - 4em);
    max-width: 32em;
    max-height: calc(100vh - 4em);
    overflow: auto;
    transform: translate(-50%, -50%);
    padding: 1em;
    border-radius: 0.2em;
    background: white;
  }

  button {
    display: inline-block;
  }
  * {
    font-family: inherit;
    font-size: inherit;
  }

  input {
    display: block;
    margin: 0 0 0.5em 0;
  }

  select {
    float: left;
    margin: 0 1em 1em 0;
    width: 14em;
  }

  .buttons {
    clear: both;
  }
</style>
